<?php
namespace Aura\Framework\Web;
use Aura\Di\Config;
use Aura\Di\Forge;

/**
 * Test class for ControllerFactory.
 * Generated by PHPUnit on 2011-03-19 at 15:01:06.
 */
class FactoryTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @var Factory
     */
    protected $factory;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    public function setUp()
    {
        parent::setUp();
    }

    protected function newFactory(array $map = [], $not_found = null)
    {
        return new Factory(
            new Forge(new Config),
            $map,
            $not_found
        );
    }
    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    public function tearDown()
    {
        parent::tearDown();
    }

    /**
     * @todo Implement testNewInstance().
     */
    public function testNewInstance()
    {
        $factory = $this->newFactory([
            'mock' => 'Aura\Framework\Mock\Page',
        ]);
        $name = 'mock';
        $params = [];
        $controller = $factory->newInstance($name, $params);
        $this->assertInstanceOf('Aura\Framework\Mock\Page', $controller);
    }
    
    public function testNewInstanceNotFound()
    {
        $factory = $this->newFactory([], 'Aura\Framework\Mock\Page');
        $name = 'no-such-name';
        $params = [];
        $controller = $factory->newInstance($name, $params);
        $this->assertInstanceOf('Aura\Framework\Mock\Page', $controller);
    }
    
    public function testNewInstanceException()
    {
        $factory = $this->newFactory();
        $name = 'no-such-name';
        $params = [];
        $this->setExpectedException('Aura\Framework\Exception\NoClassForController');
        $controller = $factory->newInstance($name, $params);
    }
}
